package org.omg.appinst;

import java.util.Map;

public interface DataProcessor {

	String getName();

	void initialize(InstrumentationService service, Map<String, String> args)
			throws ReturnCodeException;

	void finalize(InstrumentationService service);

	void update(InstrumentationService service, Map<String, String> args)
			throws ReturnCodeException;

	Object attachToObservableScope(ObservableScope scope)
			throws ReturnCodeException;

	void detachFromObservableScope(ObservableScope scope, Object scopeState)
			throws ReturnCodeException;

	Object attachToObservableObject(ObservableObject obj, Object scopeState)
			throws ReturnCodeException;

	void detachFromObservableObject(ObservableObject obj, Object scopeState,
			Object objState) throws ReturnCodeException;

	void processObservations(Observation[] observations, ObservableObject obj,
			Object scopeState, Object objState) throws ReturnCodeException;
}
