package org.omg.appinst;

import java.util.Collection;
import java.util.Date;

public interface Observation {
	int getSequenceNumber();

	Date getGenerationTimestamp();

	ObservableSchema getObservableSchema();

	void setFlag(ObservationFlagKind flag) throws ReturnCodeException;

	void unsetFlag(ObservationFlagKind flag) throws ReturnCodeException;

	boolean isSetFlag(ObservationFlagKind flag);

	void resetFlag() throws ReturnCodeException;

	boolean getValueBOOL(int fieldIndex) throws ReturnCodeException;

	char getValueCHAR8(int fieldIndex) throws ReturnCodeException;

	char getValueCHAR32(int fieldIndex) throws ReturnCodeException;

	String getValueSTRING8(int fieldIndex) throws ReturnCodeException;

	String getValueSTRING32(int fieldIndex) throws ReturnCodeException;

	short getValueINT16(int fieldIndex) throws ReturnCodeException;

	int getValueINT32(int fieldIndex) throws ReturnCodeException;

	long getValueINT64(int fieldIndex) throws ReturnCodeException;

	float getValueFLOAT32(int fieldIndex) throws ReturnCodeException;

	double getValueFLOAT64(int fieldIndex) throws ReturnCodeException;

	void setValue(int fieldIndex, boolean value) throws ReturnCodeException;

	void setValue(int fieldIndex, byte value) throws ReturnCodeException;

	void setValue(int fieldIndex, short value) throws ReturnCodeException;

	void setValue(int fieldIndex, int value) throws ReturnCodeException;

	void setValue(int fieldIndex, long value) throws ReturnCodeException;

	void setValue(int fieldIndex, float value) throws ReturnCodeException;

	void setValue(int fieldIndex, double value) throws ReturnCodeException;

	void setValue(int fieldIndex, char value) throws ReturnCodeException;

	void setValue(int fieldIndex, String value) throws ReturnCodeException;

	void setValue(int fieldIndex, Boolean value) throws ReturnCodeException;

	void setValue(int fieldIndex, Byte value) throws ReturnCodeException;

	void setValue(int fieldIndex, Short value) throws ReturnCodeException;

	void setValue(int fieldIndex, Integer value) throws ReturnCodeException;

	void setValue(int fieldIndex, Long value) throws ReturnCodeException;

	void setValue(int fieldIndex, Float value) throws ReturnCodeException;

	void setValue(int fieldIndex, Double value) throws ReturnCodeException;

	void setValue(int fieldIndex, Character value) throws ReturnCodeException;

	void setValue(int fieldIndex, boolean[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, byte[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, short[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, int[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, long[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, float[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, double[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, char[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, String[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Boolean[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Byte[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Short[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Integer[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Long[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Float[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Double[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Character[] value) throws ReturnCodeException;

	<T> void setValue(int fieldIndex, Collection<T> value)
			throws ReturnCodeException;
}
