package org.omg.appinst;

public class ReturnCodeException extends Exception {

	private static final long serialVersionUID = -8195907358701158726L;
	
	private final ReturnCode retcode;

	public ReturnCodeException(ReturnCode retcode) {
		super();
		this.retcode = retcode;
	}

	public ReturnCodeException(ReturnCode retcode, String message, Throwable cause) {
		super(message, cause);
		this.retcode = retcode;
	}

	public ReturnCodeException(ReturnCode retcode, String message) {
		super(message);
		this.retcode = retcode;
	}

	public ReturnCodeException(ReturnCode retcode, Throwable cause) {
		super(cause);	
		this.retcode = retcode;
	}

	public ReturnCode getRetcode() {
		return retcode;
	}
	
}
